/********************************************************************************
*	NOTICE:														*
*																*
*	This code is believed by the author to be bug free.  You are free to use	*
*	and modify this code with the understanding that any use, either direct	*
*	or derivative, must contain acknowledgement of its author and source.		*
*	The author makes no warranty of any kind, expressed or implied, of		*
*	merchantability or fitness for a particular purpose.  The author shall	*
*	not be held liable for any incidental or consequential damages in		*
*	connection with or arising out of the furnishing, performance, or use of	*
*	this software.  This software is not authorized for use in life support	*
*	devices or systems.												*
*																*
********************************************************************************/

// AIPP software developed by Gianluca Di Pasqua, John Oh, and Sean Hanley
// in association with the DSP Lab at the University of Toronto, 2000.

import java.awt.*;
import java.awt.image.*;
import java.io.*;

// Channels the blue component of image
public class bluefilt extends EffectFilter
{
	// Create object
	public bluefilt()
	{
	}
	
	// Runs algorithm
	public void performEffect()
	{
		int newPixels[] = new int[width*height];
		int blue = 0;
		
		// Moves through the input array pixel by pixel
		for(int k=0;k<width*height;k++)
		{
			// Isolates blue component
			blue = (pixels[k]>>0)&0xff;
			
			// Outputs blue component in greyscale
			newPixels[k] = (255<<24 | (blue<<16) | (blue<<8) | blue);
		}

		this.pixels = newPixels;
	}
}
