/********************************************************************************
*	NOTICE:														*
*																*
*	This code is believed by the author to be bug free.  You are free to use	*
*	and modify this code with the understanding that any use, either direct	*
*	or derivative, must contain acknowledgement of its author and source.		*
*	The author makes no warranty of any kind, expressed or implied, of		*
*	merchantability or fitness for a particular purpose.  The author shall	*
*	not be held liable for any incidental or consequential damages in		*
*	connection with or arising out of the furnishing, performance, or use of	*
*	this software.  This software is not authorized for use in life support	*
*	devices or systems.												*
*																*
********************************************************************************/

// AIPP software developed by Gianluca Di Pasqua, John Oh, and Sean Hanley
// in association with the DSP Lab at the University of Toronto, 2000.

import java.awt.*;
import java.awt.image.*;
import java.awt.MediaTracker;
import java.io.*;

// Greyscale Filter
public class greyfilt extends EffectFilter
{
	// Create object
	public greyfilt()
	{
	}
	
	// Runs algorithm
	public void performEffect()
	{
		int[] newPixels = new int[width*height];
		int red = 0;
		int green = 0;
		int blue = 0;
		int grey = 0;

		// Moves through the input array pixel by pixel
		for (int i=0;i<width*height;i++)
		{
			// Isolates RGB components
			red = (pixels[i]>>16)&0xff;
			green = (pixels[i]>>8)&0xff;
			blue = (pixels[i])&0xff;

			// Averages and outputs RGB components as greyscale
			grey = (red + green + blue) / 3;
    
			newPixels[i] = (0xff000000 | (grey << 16) | (grey <<  8) |  grey); 
		}
		this.pixels = newPixels;
	}
}



